<?php

//uncomment this to get it working locally
//set the header and return to the client.
//header('Content-Type: application/json');
header('Access-Control-Allow-Origin: *');
header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept");
header('Access-Control-Allow-Methods: GET, POST');
header("Access-Control-Allow-Credentials: true");

$config = include('../../configs/app-config.php');

$apiUrl = $config['apiUrl'] . 'token=' . $config['token'] . '&command=getCheckpoints';


$whitelist = array('getCheckpoints', 'addCheckpoint', 'lookupAddress');


if (isset($_REQUEST['command'])) {
	$command = $_GET['command'];
	if (in_array($command, $whitelist)) {
		
		//Check if there is a valid callback sent in.
		if (isset($_REQUEST['callback'])) {
			//validate this is a good callback.
			$callbackFunction = filter_var($_REQUEST['callback'], FILTER_SANITIZE_ENCODED);
			$pattern = '/^Ext.data.JsonP.callback$|(\d+)$/';
			if (preg_match($pattern, $callbackFunction) === 1) {
				$callback = true;
			} else {
				header("HTTP/1.1 401 Unauthorized");
			}
		}

		//Check the command the user us trying to run.
		switch ($command) {

			case 'getCheckpoints':
				//use the current date in format YearMonthDay to append to URL. This will mean people can only use Url that is one day old.
				$date = date("Ymd");

				$data = @file_get_contents($apiUrl);
				break;

			case 'addCheckpoint':
			
				//Sanitise the values passed in from our form
				$formattedAddress = filter_var($_GET['formattedAddress'], FILTER_SANITIZE_STRING);
				$latitude = filter_var($_GET['latitude'], FILTER_SANITIZE_NUMBER_FLOAT, FILTER_FLAG_ALLOW_FRACTION);
				$longitide = filter_var($_GET['longitide'], FILTER_SANITIZE_NUMBER_FLOAT, FILTER_FLAG_ALLOW_FRACTION);
				$checkpointType = filter_var($_GET['checkpointType'], FILTER_SANITIZE_STRING);

				//Check if our values have a minimum of three characters.
				if (strlen($formattedAddress) < 3 || strlen($latitude) < 3 || strlen($longitide) < 3 || strlen($checkpointType) < 3) {
					die('form values too short');
				}

				$curl_post_data = array(
					'token' => '9cGt3', 
					'command' => 'addCheckpoint', 
					'formattedAddress' => $formattedAddress,
					'latitude' => $latitude,
					'longitide' => $longitide,
					'checkpointType' => $checkpointType
				);

       			$curl = curl_init($config['apiUrl']);
       			curl_setopt($curl, CURLOPT_HEADER, false);
       			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
       			curl_setopt($curl, CURLOPT_POST, true);
       			curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($curl_post_data, '', '&'));
       			$data = curl_exec($curl);
       			$status = curl_getinfo($curl, CURLINFO_HTTP_CODE);
       			curl_close($curl);
	
				break;	
		}

		//uncomment this to get it working locally
		//set the header and return to the client.
		//header('Content-Type: application/json');
		header('Access-Control-Allow-Origin: *');
		header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept");
		header('Access-Control-Allow-Methods: GET, POST');
		header("Access-Control-Allow-Credentials: true");

		if ($callback) {
			$data = $callbackFunction.'('.$data.')';
		}
		echo $data;
	}
};
